# frozen_string_literal: true

require_relative 'codebreaker/index'

module Codebreaker
  STAT_FILE = './statistic.yaml'
  NoAttamptsError = Class.new(ArgumentError)
  class << self
    def create(**diffucult)
      BLL::GameEngine.new(**diffucult)
    end

    def save_statistic(path, **statistic_info)
      [].tap do |data_to_write|
        data_to_write << statistic_info

        create_db path

        data_to_write.concat YAML.load_file(path) if YAML.load_file(path)

        File.open(path, 'w') { |file| file.write(data_to_write.to_yaml) }
      end
    end

    def fetch_statistic(path)
      create_db path

      YAML.load_file path
    end

    private

    def create_db path
      File.new path,"w" unless File.exist? path
    end
  end
end
